<?php

/**
 * get theme option
 */
function bo_get_theme_option(){
     global $opt_theme_options, $opt_meta_options;
     return $opt_theme_options;
}

/**
 * get meta option
 */
function bo_get_meta_option(){
     global $opt_meta_options;
     return $opt_meta_options;
}

/**
 * get header layout.
 */
function bo_header(){
    global $opt_theme_options, $opt_meta_options;

    if(empty($opt_theme_options)){
        get_template_part('inc/header/header', 'default');
        return;
    }
 
    /* load custom header template. */
    get_template_part('inc/header/header', $opt_theme_options['header_layout']);
}

/**
 * get theme logo.
 */
function bo_header_logo(){
    global $opt_theme_options, $opt_meta_options;
    
    echo '<div class="main_logo">';

    if(isset($opt_theme_options['logo_type']) && $opt_theme_options['logo_type'] && !empty($opt_theme_options['main_logo']['url'])) {
        echo '<a class="main-logo" href="' . esc_url(home_url('/')) . '"><img alt="' .  get_bloginfo( "name" ) . '" src="' . esc_url($opt_theme_options['main_logo']['url']) . '"></a>';
        if(!empty($opt_theme_options['tran_logo']['url']))
            echo '<a class="tran-logo" href="' . esc_url(home_url('/')) . '"><img alt="' .  get_bloginfo( "name" ) . '" src="' . esc_url($opt_theme_options['tran_logo']['url']) . '"></a>';
    } elseif (isset($opt_theme_options['logo_type']) && !$opt_theme_options['logo_type'] && !empty($opt_theme_options['logo_text'])){
        echo '<h1 class="site-title"><a href="' . esc_url( home_url( '/' )) . '" rel="home">' . esc_html($opt_theme_options['logo_text']) . '</a></h1>';

        if(!empty($opt_theme_options['logo_text_sologan']))
            echo '<p class="site-description">'.esc_html($opt_theme_options['logo_text_sologan']).'</p>';

    } else {
        echo '<h1 class="site-title"><a href="' . esc_url( home_url( '/' )) . '" rel="home">' . get_bloginfo( "name" ) . '</a></h1>';
        echo '<p class="site-description">' . get_bloginfo( "description" ) . '</p>';
    }

    echo '</div>';

    bo_header_sticky_logo();
}

/**
 * get theme logo.
 */
function bo_header_sticky_logo(){
    global $opt_theme_options;

    /* sticky off. */
    if(!isset($opt_theme_options['menu_sticky']) || !$opt_theme_options['menu_sticky'])
        return;

    /* default logo. */
    if(!isset($opt_theme_options['sticky_logo_type']) || $opt_theme_options['sticky_logo_type'] == 'default')
        return;

    echo '<div class="sticky_logo hide">';

    if(isset($opt_theme_options['sticky_logo_type']) && $opt_theme_options['sticky_logo_type'] == 'img' && !empty($opt_theme_options['sticky_logo']['url'])) {
        echo '<a href="' . esc_url(home_url('/')) . '"><img alt="' .  get_bloginfo( "name" ) . '" src="' . esc_url($opt_theme_options['sticky_logo']['url']) . '"></a>';
    } elseif (isset($opt_theme_options['sticky_logo_type']) && $opt_theme_options['sticky_logo_type'] == 'text' && !empty($opt_theme_options['sticky_logo_text'])){
        echo '<h1 class="site-title"><a href="' . esc_url( home_url( '/' )) . '" rel="home">' . esc_html($opt_theme_options['sticky_logo_text']) . '</a></h1>';

        if(!empty($opt_theme_options['sticky_logo_text_sologan']))
            echo '<p class="site-description">'.esc_html($opt_theme_options['sticky_logo_text_sologan']).'</p>';

    } else {
        echo '<h1 class="site-title"><a href="' . esc_url( home_url( '/' )) . '" rel="home">' . get_bloginfo( "name" ) . '</a></h1>';
        echo '<p class="site-description">' . get_bloginfo( "description" ) . '</p>';
    }

    echo '</div>';
}
 
/**
 * get header class.
 */
function bo_header_class($class = ''){
    global $opt_theme_options;

    if(empty($opt_theme_options)){
        echo esc_attr($class);
        return;
    }

    if($opt_theme_options['menu_sticky'])
        $class .= ' sticky-desktop';

    echo esc_attr($class);
}

/**
 * main navigation.
 */
function bo_header_navigation(){

    global $opt_meta_options;

    $attr = array(
        'menu_class' => 'nav-menu menu-main-menu',
        'theme_location' => 'primary'
    );

    if(is_page() && !empty($opt_meta_options['header_menu']))
        $attr['menu'] = $opt_meta_options['header_menu'];

    /* enable mega menu. */
    if(class_exists('HeroMenuWalker')){ $attr['walker'] = new HeroMenuWalker(); }

    $locations = get_nav_menu_locations();

    if(empty($locations[ 'primary' ]))
        return;

    /* main nav. */
    wp_nav_menu( $attr );
}

/**
 * get cart search icon in right of main menu
 */
function bo_header_nav_right(){
    global $opt_theme_options;
    if(class_exists( 'WooCommerce' ))
        global $woocommerce; 
    if(!empty($opt_theme_options['hr_show_cart']) || !empty($opt_theme_options['hr_show_search'])) {   
    ?>
    <ul class="nav navbar-nav navbar-right searchandbag pull-right hidden-xs hidden-sm">  
        <?php if(!empty($opt_theme_options['hr_show_search']) && $opt_theme_options['hr_show_search']=='1'){ ?>
        <li class="dropdown searchdropdown hasmenu">
            <a href="#" class="search-icon search-opener"><i class="pe-7s-search"></i></a>
        </li>
        <?php } ?>
        <?php 
        if(!empty($opt_theme_options['hr_show_cart']) && $opt_theme_options['hr_show_cart']=='1'){ 
        if(class_exists( 'WooCommerce' )){
        ?>
        <li class="dropdown hasmenu shopcartmenu">
            <a href="#" class="cart-icon" data-toggle="dropdown" aria-expanded="false"><span class="countbadge hidden-xs"><?php echo $woocommerce->cart->get_cart_contents_count();?></span> <i class="lnr lnr-store"></i></a>
            <ul class="dropdown-menu start-right">
                <li class="shopcart shopping_cart_dropdown">
                    <div class="shopping_cart_dropdown_inner widget_shopping_cart_content">
                    <?php woocommerce_mini_cart(); ?>
                    </div>
                </li>
            </ul>
        </li>
        <?php }} ?>
         
    </ul>
    <?php
    }
}

/**
 * Change search form
 **/
function bo_my_search_form( $form ) {
    $form = '<form method="get" action="'. esc_url( home_url( '/'  ) ).'">
            <input type="text" class="form-control input-lg" value="' . get_search_query() . '" name="s" placeholder="'.esc_html__("Search...",'wpbo').'" />
                <button class="btn" type="submit">
                    <i class="pe-7s-search"></i>
                </button>
             ';
         $form .='</form>';
    return $form;
}
add_filter( 'get_search_form', 'bo_my_search_form' );

/**
 * get page title layout
 */
function bo_page_title(){
    global $opt_theme_options, $opt_meta_options;
    
    if(is_404()) return;
    /* default. */
    $layout = '4';

    /* get theme options */
    if(isset($opt_theme_options['page_title_layout']))
        $layout = $opt_theme_options['page_title_layout'];
    
    if(isset($opt_theme_options['page_title_layout']))
        $layout = $opt_theme_options['page_title_layout'];
        
    if(isset($opt_meta_options['disable_page_title']) && $opt_meta_options['disable_page_title']=='1'){
        return;
    }
    
    /* custom layout from page. */
    if(is_page() && !empty($opt_meta_options['page_title_layout']))
        $layout = $opt_meta_options['page_title_layout'];
    
    $page_title_align = '';
    if(!empty($opt_theme_options['page_title_align'])){
        $page_title_align = $opt_theme_options['page_title_align'];
    }
    ?>
    <div id="page-title" class="page-title layout_<?php echo esc_attr($layout);?>">
    <?php if(isset($opt_theme_options['page_title_is_overlay']) && $opt_theme_options['page_title_is_overlay']=='1') echo '<div class="bg-overlay"></div>'; ?>
        <div class="container">
        <div class="row">
        <?php switch ($layout){
            case '2':
                ?>
                <div id="page-title-text" class="col-xs-12 col-sm-12 col-md-12 col-lg-12 <?php echo esc_attr($page_title_align);?>"><h2><?php bo_get_page_title(); ?></h2></div>
                <div id="breadcrumb-text" class="col-xs-12 col-sm-12 col-md-12 col-lg-12 <?php echo esc_attr($page_title_align);?>"><?php bo_get_bread_crumb(); ?></div>
                <?php
                break;
            case '3':
                ?>
                <div id="breadcrumb-text" class="col-xs-12 col-sm-12 col-md-12 col-lg-12 <?php echo esc_attr($page_title_align);?>"><?php bo_get_bread_crumb(); ?></div>
                <div id="page-title-text" class="col-xs-12 col-sm-12 col-md-12 col-lg-12 <?php echo esc_attr($page_title_align);?>"><h2><?php bo_get_page_title(); ?></h2></div>
                <?php
                break;
            case '4':
                ?>
                <div id="page-title-text" class="col-xs-12 col-sm-6 col-md-6 col-lg-6"><h2><?php bo_get_page_title(); ?></h2></div>
                <div id="breadcrumb-text" class="col-xs-12 col-sm-6 col-md-6 col-lg-6 text-right"><?php bo_get_bread_crumb(); ?></div>
                <?php
                break;
            case '5':
                ?>
                <div id="breadcrumb-text" class="col-xs-12 col-sm-6 col-md-6 col-lg-6"><?php bo_get_bread_crumb(); ?></div>
                <div id="page-title-text" class="col-xs-12 col-sm-6 col-md-6 col-lg-6 text-right"><h2><?php bo_get_page_title(); ?></h2></div>
                <?php
                break;
            case '6':
                ?>
                <div id="page-title-text" class="col-xs-12 col-sm-12 col-md-12 col-lg-12 <?php echo esc_attr($page_title_align);?>"><h2><?php bo_get_page_title(); ?></h2></div>
                <?php
                break;
            case '7':
                ?>
                <div id="breadcrumb-text" class="col-xs-12 col-sm-12 col-md-12 col-lg-12 <?php echo esc_attr($page_title_align);?>"><?php bo_get_bread_crumb(); ?></div>
                <?php
                break;
        } ?>
        </div>
        </div>
    </div><!-- #page-title -->
    <?php
}

/**
 * page title
 */
function bo_get_page_title(){

    global $opt_meta_options;

    if (!is_archive()){
        /* page. */
        if(is_page()) :
            /* custom title. */
            if(!empty($opt_meta_options['page_title_text'])):
                echo esc_html($opt_meta_options['page_title_text']);
            else :
                the_title();
            endif;
        elseif (is_front_page()):
            esc_html_e('Blog', 'wpbo');
        /* search */
        elseif (is_search()):
            printf( esc_html__( 'Search Results for: %s', 'wpbo' ), '<span>' . get_search_query() . '</span>' );
        /* 404 */
        elseif (is_404()):
            esc_html_e( '404', 'wpbo');
        /* other */
        else :
            the_title();
        endif;
    } else {
        /* category. */
        if ( is_category() ) :
            single_cat_title();
        elseif ( is_tag() ) :
            /* tag. */
            single_tag_title();
        /* author. */
        elseif ( is_author() ) :
            printf( esc_html__( 'Author: %s', 'wpbo' ), '<span class="vcard">' . get_the_author() . '</span>' );
        /* date */
        elseif ( is_day() ) :
            printf( esc_html__( 'Day: %s', 'wpbo' ), '<span>' . get_the_date() . '</span>' );
        elseif ( is_month() ) :
            printf( esc_html__( 'Month: %s', 'wpbo' ), '<span>' . get_the_date() . '</span>' );
        elseif ( is_year() ) :
            printf( esc_html__( 'Year: %s', 'wpbo' ), '<span>' . get_the_date() . '</span>' );
        /* post format */
        elseif ( is_tax( 'post_format', 'post-format-aside' ) ) :
            esc_html_e( 'Asides', 'wpbo' );
        elseif ( is_tax( 'post_format', 'post-format-gallery' ) ) :
            esc_html_e( 'Galleries', 'wpbo');
        elseif ( is_tax( 'post_format', 'post-format-image' ) ) :
            esc_html_e( 'Images', 'wpbo');
        elseif ( is_tax( 'post_format', 'post-format-video' ) ) :
            esc_html_e( 'Videos', 'wpbo' );
        elseif ( is_tax( 'post_format', 'post-format-quote' ) ) :
            esc_html_e( 'Quotes', 'wpbo' );
        elseif ( is_tax( 'post_format', 'post-format-link' ) ) :
            esc_html_e( 'Links', 'wpbo' );
        elseif ( is_tax( 'post_format', 'post-format-status' ) ) :
            esc_html_e( 'Statuses', 'wpbo' );
        elseif ( is_tax( 'post_format', 'post-format-audio' ) ) :
            esc_html_e( 'Audios', 'wpbo' );
        elseif ( is_tax( 'post_format', 'post-format-chat' ) ) :
            esc_html_e( 'Chats', 'wpbo' );
        /* woocommerce */
        elseif (function_exists('is_woocommerce') && is_woocommerce()):
            woocommerce_page_title();
        else :
            /* other */
            the_title();
        endif;
    }
}

/**
 * Breadcrumb NavXT
 *
 * @since 1.0.0
 */
function bo_get_bread_crumb() {

    if(!function_exists('bcn_display')) return;

    bcn_display();
}
 
/**
 * Display an optional post video.
 */
function bo_post_video() {

    global $opt_meta_options, $wp_embed;

    /* no video. */
    if(empty($opt_meta_options['opt-video-type'])) {
        bo_post_thumbnail();
        return;
    }

    if($opt_meta_options['opt-video-type'] == 'local' && !empty($opt_meta_options['otp-video-local']['id'])){

        $video = wp_get_attachment_metadata($opt_meta_options['otp-video-local']['id']);

        echo do_shortcode('[video width="'.esc_attr($opt_meta_options['otp-video-local']['width']).'" height="'.esc_attr($opt_meta_options['otp-video-local']['height']).'" '.$video['fileformat'].'="'.esc_url($opt_meta_options['otp-video-local']['url']).'" poster="'.esc_url($opt_meta_options['otp-video-thumb']['url']).'"][/video]');

    } elseif($opt_meta_options['opt-video-type'] == 'youtube' && !empty($opt_meta_options['opt-video-youtube'])) {

        echo do_shortcode($wp_embed->run_shortcode('[embed]'.esc_url($opt_meta_options['opt-video-youtube']).'[/embed]'));

    } elseif($opt_meta_options['opt-video-type'] == 'vimeo' && !empty($opt_meta_options['opt-video-vimeo'])) {

        echo do_shortcode($wp_embed->run_shortcode('[embed]'.esc_url($opt_meta_options['opt-video-vimeo']).'[/embed]'));

    }
}

/**
 * Display an optional post audio.
 */
function bo_post_audio() {
    global $opt_meta_options;

    /* no audio. */
    if(empty($opt_meta_options['otp-audio']['id'])) {
        bo_post_thumbnail();
        return;
    }

    $audio = wp_get_attachment_metadata($opt_meta_options['otp-audio']['id']);

    echo do_shortcode('[audio '.$audio['fileformat'].'="'.esc_url($opt_meta_options['otp-audio']['url']).'"][/audio]');
}

/**
 * Display an optional post gallery.
 */
function bo_post_gallery($size = 'full'){
    global $opt_theme_options, $opt_meta_options;

    /* no audio. */
    if(empty($opt_meta_options['opt-gallery'])) {
        bo_post_thumbnail();
        return;
    }
    $size = 'medium';
    
    if(isset($opt_theme_options['archive_layout'])){ 
        if($opt_theme_options['archive_layout'] == 'full' && $opt_theme_options['blog_columns_full'] == 'col-xs-12 col-sm-12 col-md-12 col-lg-12' )
            $size = 'large';
        else
            if($opt_theme_options['blog_columns'] == 'col-xs-12 col-sm-12 col-md-12 col-lg-12')
                $size = 'large';
            else 
                $size = 'wpbo-420-290';
    }
      
    if(is_single()) $size = 'full';
    
    $array_id = explode(",", $opt_meta_options['opt-gallery']);
    
    ?>
    <div id="carousel-post-gallery" class="carousel slide" data-ride="carousel">
        <div class="carousel-inner">
            <?php $i = 0; ?>
            <?php foreach ($array_id as $image_id): ?>
                <?php
                $attachment_image = wp_get_attachment_image_src($image_id, $size, false);
                if($attachment_image[0] != ''):?>
                    <div class="item <?php if( $i == 0 ){ echo 'active'; } ?>">
                        <img style="width:100%;" data-src="holder.js" src="<?php echo esc_url($attachment_image[0]);?>" alt="" />
                    </div>
                <?php $i++; endif; ?>
            <?php endforeach; ?>
        </div>
        <a class="left carousel-control" href="#carousel-post-gallery" data-slide="prev">
            <span class="pe-7s-angle-left"></span>
        </a>
        <a class="right carousel-control" href="#carousel-post-gallery" data-slide="next">
            <span class="pe-7s-angle-right"></span>
        </a>
    </div>
    <?php
}

/**
 * Display an optional post quote.
 */
function bo_post_quote() {
    global $opt_meta_options;

    if(empty($opt_meta_options['opt-quote-content'])){
        bo_post_thumbnail();
        return;
    }

    $opt_meta_options['opt-quote-title'] = !empty($opt_meta_options['opt-quote-title']) ? '<span>'.esc_html($opt_meta_options['opt-quote-title']).'</span>' : '' ;

    echo '<blockquote>'.esc_html($opt_meta_options['opt-quote-content']).wp_kses_post($opt_meta_options['opt-quote-title']).'</blockquote>';
}

/**
 * Display an optional post thumbnail.
 *
 * Wraps the post thumbnail in an anchor element on index
 * views, or a div element when on single views.
 */
function bo_post_thumbnail() {
     
    global $opt_theme_options;
    if ( post_password_required() || is_attachment() || ! has_post_thumbnail() ) {
        return;
    }
     
    $img_size = 'medium';
    
    if(isset($opt_theme_options['archive_layout'])){ 
        if($opt_theme_options['archive_layout'] == 'full' && $opt_theme_options['blog_columns_full'] == 'col-xs-12 col-sm-12 col-md-12 col-lg-12' )
            $img_size = 'large';
        else
            if($opt_theme_options['blog_columns'] == 'col-xs-12 col-sm-12 col-md-12 col-lg-12')
                $img_size = 'large';
            else 
                $img_size = 'wpbo-420-290';
    }
      
    if(is_single()) $img_size = 'large';
    echo '<div class="post-thumbnail">';
            the_post_thumbnail($img_size);
    echo '</div>';
 
}

function bo_post_sidebar(){
    global $opt_theme_options;

    $_sidebar = 'right';

    if(isset($opt_theme_options['single_layout']))
        $_sidebar = $opt_theme_options['single_layout'];

    return 'is-sidebar-' . esc_attr($_sidebar);
}

function bo_post_class(){
    global $opt_theme_options;

    $_class = "col-xs-12 col-sm-12 col-md-9 col-lg-9";

    if(isset($opt_theme_options['single_layout']) && $opt_theme_options['single_layout'] == 'full')
        $_class = "col-xs-12 col-sm-12 col-md-12 col-lg-12";

    echo esc_attr($_class);
}
/**
 * Display an optional post detail.
 */
function bo_post_detail(){
    global $opt_theme_options;
    $archive_year  = get_the_time('Y'); 
    $archive_month = get_the_time('m'); 
    $archive_day   = get_the_time('d'); 
    ?>
    <ul class="single_detail">

        <?php if(isset($opt_theme_options['single_author']) && $opt_theme_options['single_author']): ?>

            <li class="detail-author"><?php echo esc_html__('by:','wpbo'); ?> <?php the_author_posts_link(); ?></li>

        <?php endif; ?>

        <?php if(has_category() && (!isset($opt_theme_options['single_categories']) || (isset($opt_theme_options['single_categories']) && $opt_theme_options['single_categories']))): ?>

            <li class="detail-terms"><?php the_terms( get_the_ID(), 'category', '', ' / ' ); ?></li>

        <?php endif; ?>

        <?php if(!isset($opt_theme_options['single_comment']) || (isset($opt_theme_options['single_comment']) && $opt_theme_options['single_comment'])): ?>

            <li class="detail-comment"><a href="<?php the_permalink(); ?>"><?php echo esc_html(comments_number('0','1','%')); ?> <?php esc_html_e('Comments', 'wpbo'); ?></a></li>

        <?php endif; ?>

        <?php if(has_tag() && (!isset($opt_theme_options['single_tag']) || (isset($opt_theme_options['single_tag']) && $opt_theme_options['single_tag']))): ?>

            <li class="detail-tags"><?php the_tags('', ', ' ); ?></li>

        <?php endif; ?>

        <?php if(!isset($opt_theme_options['single_date']) || (isset($opt_theme_options['single_date']) && $opt_theme_options['single_date'])): ?>

            <li class="detail-date"><a href="<?php echo get_day_link( $archive_year, $archive_month, $archive_day); ?>"><?php the_date(); ?></a></li>

        <?php endif; ?>

    </ul>
    <?php
}

/**
 * Display single entry footer
 */
function bo_archive_entry_footer(){
    global $opt_theme_options;
    if(!isset($opt_theme_options['archive_read_more']) || (isset($opt_theme_options['archive_read_more']) && $opt_theme_options['archive_read_more'])){
        echo '<footer class="entry-footer">';
            echo '<a class="readmore" href="'. get_the_permalink().'">'. esc_html__('More', 'wpbo') .' <i class="fa fa-angle-double-right"></i></a>';
        echo '</footer> ';
    }
}

/**
 * Display single entry footer
 */
function bo_entry_footer(){
    global $opt_theme_options;
    if( ( isset($opt_theme_options['single_footer_tag']) && $opt_theme_options['single_footer_tag']) || (isset($opt_theme_options['single_footer_social']) && $opt_theme_options['single_footer_social']) ){
        echo '<footer class="entry-footer">';
            if(has_tag() && (!isset($opt_theme_options['single_footer_tag']) || (isset($opt_theme_options['single_footer_tag']) && $opt_theme_options['single_footer_tag'])))
                the_tags( '<span class="tag-label">'.esc_html__('Tags: ','wpbo').'</span><span class="tag-links">', ',', '</span>' );
            if(isset($opt_theme_options['single_footer_social']) && $opt_theme_options['single_footer_social'])
                bo_footer_share();
        echo '</footer>';
    }
}
/**
 * Display an optional archive detail.
 */
function bo_archive_detail(){
    global $opt_theme_options;
    $archive_year  = get_the_time('Y'); 
    $archive_month = get_the_time('m'); 
    $archive_day   = get_the_time('d'); 
    ?>
    <ul class="archive_detail">

        <?php if(!isset($opt_theme_options['archive_author']) || (isset($opt_theme_options['archive_author']) && $opt_theme_options['archive_author'])): ?>

            <li class="detail-author"><?php echo esc_html__('by:','wpbo'); ?> <?php the_author_posts_link(); ?></li>

        <?php endif; ?>

        <?php if(has_category() && (!isset($opt_theme_options['archive_categories']) || (isset($opt_theme_options['archive_categories']) && $opt_theme_options['archive_categories']))): ?>

            <li class="detail-terms"><?php the_terms( get_the_ID(), 'category', '', ' / ' ); ?></li>

        <?php endif; ?>

        <?php if(!isset($opt_theme_options['archive_comment']) || (isset($opt_theme_options['archive_comment']) && $opt_theme_options['archive_comment'])): ?>

            <li class="detail-comment"><a href="<?php the_permalink(); ?>"><?php echo esc_html(comments_number('0','1','%')); ?> <?php esc_html_e('Comments', 'wpbo'); ?></a></li>

        <?php endif; ?>

        <?php if(has_tag() && (!isset($opt_theme_options['archive_tag']) || (isset($opt_theme_options['archive_tag']) && $opt_theme_options['archive_tag']))): ?>

            <li class="detail-tags"><?php the_tags('', ', ' ); ?></li>

        <?php endif; ?>

        <?php if(!isset($opt_theme_options['archive_date']) || (isset($opt_theme_options['archive_date']) && $opt_theme_options['archive_date'])): ?>
            <li class="detail-date"><a href="<?php echo get_day_link( $archive_year, $archive_month, $archive_day); ?>"><?php echo get_the_date(); ?></a></li>
             
        <?php endif; ?>

    </ul>
    <?php
}

function bo_archive_sidebar(){
    global $opt_theme_options;

    $_sidebar = 'right';

    if(isset($opt_theme_options['archive_layout']))
        $_sidebar = $opt_theme_options['archive_layout'];
        
    if(isset($_GET['layout']) && trim($_GET['layout']) == 'full' )
        $_sidebar = 'full';
    if(isset($_GET['layout']) && trim($_GET['layout']) == 'left' )
        $_sidebar = 'left';
    if(isset($_GET['layout']) && trim($_GET['layout']) == 'right' )
        $_sidebar = 'right';
        
    return 'is-sidebar-' . esc_attr($_sidebar);
}

function bo_archive_class(){
    global $opt_theme_options;

    $_class = "col-xs-12 col-sm-12 col-md-9 col-lg-9";

    if(isset($opt_theme_options['archive_layout']) && $opt_theme_options['archive_layout'] == 'full')
        $_class = "col-xs-12 col-sm-12 col-md-12 col-lg-12";
        
    if(isset($_GET['layout']) && trim($_GET['layout']) == 'full' )
        $_class = "col-xs-12 col-sm-12 col-md-12 col-lg-12";
    if(isset($_GET['layout']) && trim($_GET['layout']) == 'left' )
        $_class = "col-xs-12 col-sm-12 col-md-9 col-lg-9";
    if(isset($_GET['layout']) && trim($_GET['layout']) == 'right' )
        $_class = "col-xs-12 col-sm-12 col-md-9 col-lg-9";
        
        
    echo esc_attr($_class);
}

/**
 * footer layout
 */
function bo_footer_top(){
    global $opt_theme_options;

    /* footer-top */
    if(empty($opt_theme_options['footer-top-column']))
        return;

    $_class = "";

    switch ($opt_theme_options['footer-top-column']){
        case '1':
            $_class = 'col-lg-12 col-md-12 col-sm-12 col-xs-12';
            break;
        case '2':
            $_class = 'col-lg-6 col-md-6 col-sm-6 col-xs-12';
            break;
        case '3':
            $_class = 'col-lg-4 col-md-4 col-sm-4 col-xs-12';
            break;
        case '4':
            $_class = 'col-lg-3 col-md-3 col-sm-6 col-xs-12';
            break;
    }
    if ( is_active_sidebar( 'sidebar-footer-top-1' ) || isset($opt_theme_options['footer_logo_type']) ){
        echo '<div class="' . esc_attr($_class) . '">';
            $footer_logo_url = !empty($opt_theme_options['footer_logo_url']) ? $opt_theme_options['footer_logo_url'] : home_url('/') ;
            if(isset($opt_theme_options['footer_logo_type']) && $opt_theme_options['footer_logo_type'] && !empty($opt_theme_options['footer_logo']['url'])) {
                echo '<h1 class="site-title"><a href="' . esc_url($footer_logo_url) . '"><img alt="' .  get_bloginfo( "name" ) . '" src="' . esc_url($opt_theme_options['footer_logo']['url']) . '"></a></h1>';
            } elseif (isset($opt_theme_options['footer_logo_type']) && !$opt_theme_options['footer_logo_type'] && !empty($opt_theme_options['footer_logo_text'])){
                echo '<h1 class="site-title"><a href="' . esc_url($footer_logo_url) . '" rel="home">' . esc_html($opt_theme_options['footer_logo_text']) . '</a></h1>';
            }  
            dynamic_sidebar( 'sidebar-footer-top-1' );
            bo_social_from_themeoption('footer');
        echo "</div>";
    }
     
    for($i = 2 ; $i <= $opt_theme_options['footer-top-column'] ; $i++){
        if ( is_active_sidebar( 'sidebar-footer-top-' . $i ) ){
            echo '<div class="' . esc_attr($_class) . '">';
                dynamic_sidebar( 'sidebar-footer-top-' . $i );
            echo "</div>";
        }
    }
}

function bo_footer_bottom(){
    global $opt_theme_options;

    /* footer-top */
    if(empty($opt_theme_options['footer-bottom-column']))
        return;

    $_class = "";
      
    switch ($opt_theme_options['footer-bottom-column']){
        case '1':
            $_class = 'col-lg-12 col-md-12 col-sm-12 col-xs-12 ';
            break;
        case '2':
            $_class = 'col-lg-6 col-md-6 col-sm-6 col-xs-12 ';
            break;
        case '3':
            $_class = 'col-lg-4 col-md-4 col-sm-6 col-xs-12 ';
            break;
        case '4':
            $_class = 'col-lg-3 col-md-3 col-sm-6 col-xs-12 ';
            break;
    }

    for($i = 1 ; $i <= $opt_theme_options['footer-bottom-column'] ; $i++){
        if ( is_active_sidebar( 'sidebar-footer-bottom-' . $i ) ){
            echo '<div class="' . esc_html($_class) . '">';
            dynamic_sidebar( 'sidebar-footer-bottom-' . $i );
            echo "</div>";
        }
    }
}

function bo_footer_back_to_top(){
    global $opt_theme_options;

    $_back_to_top = true;

    if(isset($opt_theme_options['general_back_to_top']))
        $_back_to_top = $opt_theme_options['general_back_to_top'];

    if($_back_to_top)
        echo '<div class="ef3-back-to-top"><i class="fa fa-angle-up"></i></div>';
}

/**
 * Show social list from theme option
 */
function bo_social_from_themeoption($layout = '', $align = '') {
    global $opt_theme_options;
    $lists = '';
    if (!empty($layout ) && $layout == 'footer') {
        $lists = ( !empty($opt_theme_options['individual_social_on_footer']['enabled']) ) ? $opt_theme_options['individual_social_on_footer']['enabled'] : '';
    }  
    if ( $lists ) {
        echo '<div class="social-indiv-wrap layout-'.$layout.' '.$align.'"><ul class="social-indiv-inner">';
        foreach ($lists as $key => $value) {
            switch ($key) {
                case 'facebook':
                    echo '<li class="'.esc_attr($key).'"><a href="'.esc_url($opt_theme_options[$key]).'"><i class="fa fa-facebook"></i></a></li>';
                    break;
                case 'twitter':
                    echo '<li class="'.esc_attr($key).'"><a href="'.esc_url($opt_theme_options[$key]).'" target="_blank"><i class="fa fa-twitter"></i></a></li>';
                    break;
                case 'rss':
                    echo '<li class="'.esc_attr($key).'"><a href="'.esc_url($opt_theme_options[$key]).'" target="_blank"><i class="fa fa-rss"></i></a></li>';
                    break;
                case 'instagram':
                    echo '<li class="'.esc_attr($key).'"><a href="'.esc_url($opt_theme_options[$key]).'" target="_blank"><i class="fa fa-instagram"></i></a></li>';
                    break;
                case 'google':
                    echo '<li class="'.esc_attr($key).'"><a href="'.esc_url($opt_theme_options[$key]).'" target="_blank"><i class="fa fa-google-plus"></i></a></li>';
                    break;
                case 'skype':
                    echo '<li class="'.esc_attr($key).'"><a href="'.esc_url($opt_theme_options[$key]).'" target="_blank"><i class="fa fa-skype"></i></a></li>';
                    break;
                case 'pinterest':
                    echo '<li class="'.esc_attr($key).'"><a href="'.esc_url($opt_theme_options[$key]).'" target="_blank"><i class="fa fa-pinterest"></i></a></li>';
                    break;
                case 'vimeo':
                    echo '<li class="'.esc_attr($key).'"><a href="'.esc_url($opt_theme_options[$key]).'" target="_blank"><i class="fa fa-vimeo"></i></a></li>';
                    break;
                case 'youtube':
                    echo '<li class="'.esc_attr($key).'"><a href="'.esc_url($opt_theme_options[$key]).'" target="_blank"><i class="fa fa-youtube"></i></a></li>';
                    break;
                case 'yelp':
                    echo '<li class="'.esc_attr($key).'"><a href="'.esc_url($opt_theme_options[$key]).'" target="_blank"><i class="fa fa-yelp"></i></a></li>';
                    break;
                case 'tublr':
                    echo '<li class="'.esc_attr($key).'"><a href="'.esc_url($opt_theme_options[$key]).'" target="_blank"><i class="fa fa-tublr"></i></a></li>';
                    break;
                case 'linkedin':
                    echo '<li class="'.esc_attr($key).'"><a href="'.esc_url($opt_theme_options[$key]).'" target="_blank"><i class="fa fa-linkedin"></i></a></li>';
                    break;
                case 'behance':
                    echo '<li class="'.esc_attr($key).'"><a href="'.esc_url($opt_theme_options[$key]).'" target="_blank"><i class="fa fa-behance"></i></a></li>';
                    break;
                case 'dribbble':
                    echo '<li class="'.esc_attr($key).'"><a href="'.esc_url($opt_theme_options[$key]).'" target="_blank"><i class="fa fa-dribbble"></i></a></li>';
                    break;
            }
        }
        echo '</ul></div>';
    }  
}
/**
 * Display social share in single footer.
 */
function bo_footer_share(){
    ?>
        <div class="entry-share">
            <ul class="social-share">
                <li class="social-share-label"><?php echo esc_html__('Share:','wpbo');?></li>
                <li><a class="twitter" target="_blank" href="https://twitter.com/home?status=<?php esc_html_e('Check out this article', 'wpbo');?>:%20<?php echo strip_tags(get_the_title());?>%20-%20<?php the_permalink();?>"><i aria-hidden="true" class="fa fa-twitter"></i></a></li>
                <li><a class="facebook" target="_blank" href="https://www.facebook.com/sharer/sharer.php?u=<?php the_permalink();?>"><i aria-hidden="true" class="fa fa-facebook"></i></a></li>
                <li><a class="google" target="_blank" href="https://plus.google.com/share?url=<?php the_permalink();?>"><i aria-hidden="true" class="fa fa-google-plus"></i></a></li>
                <li><a class="pinterest" target="_blank" href="https://pinterest.com/pin/create/button/?url=<?php echo urlencode(get_the_permalink());?>"><i class="fa fa-pinterest"></i></a></li>
            </ul>
        </div>
    <?php
}

/**
 * get arcive class.
 */
function bo_get_archive_class(){
    global $opt_theme_options;
    $arcive_cls = 'col-xs-12 col-sm-6 col-md-4 col-lg-4';
    if(isset($opt_theme_options['archive_layout'])){ 
        if($opt_theme_options['archive_layout'] == 'full' || (isset($_GET['layout']) && trim($_GET['layout']) == 'full'))
            $arcive_cls = $opt_theme_options['blog_columns_full'];
        if($opt_theme_options['archive_layout'] == 'left' || (isset($_GET['layout']) && trim($_GET['layout']) == 'left'))
            $arcive_cls = $opt_theme_options['blog_columns'];    
        if($opt_theme_options['archive_layout'] == 'right' || (isset($_GET['layout']) && trim($_GET['layout']) == 'right'))
            $arcive_cls = $opt_theme_options['blog_columns'];
    }
    return $arcive_cls;
}

/**
 * Display an optional gallery gallery.
 */
function bo_portfolio_gallery(){
    global $opt_meta_options;
 
    ?>
    <div class="page-wrapper post-media">
        <?php 
        if(empty($opt_meta_options['opt_port_gallery'])) {
            red_organicfood_post_thumbnail('large');   
        }else{
            $array_id = explode(",", $opt_meta_options['opt_port_gallery']);
            ?>
             <div id="carousel-port-gallery" class="carousel slide" data-ride="carousel">
                <div class="carousel-inner">
                    <?php $i = 0; ?>
                    <?php foreach ($array_id as $image_id): ?>
                        <?php
                        $attachment_image = wp_get_attachment_image_src($image_id, 'large', false);
                        if($attachment_image[0] != ''):?>
                            <div class="item <?php if( $i == 0 ){ echo 'active'; } ?>">
                                <img style="width:100%;" data-src="holder.js" src="<?php echo esc_url($attachment_image[0]);?>" alt="" />
                            </div>
                        <?php $i++; endif; ?>
                    <?php endforeach; ?>
                </div>
                
                <a class="left carousel-control" href="#carousel-port-gallery" data-slide="prev">
                    <span class="pe-7s-angle-left"></span>
                </a>
                <a class="right carousel-control" href="#carousel-port-gallery" data-slide="next">
                    <span class="pe-7s-angle-right"></span>
                </a>
            </div>
        <?php } ?> 
    </div>
    <?php
} 

/**
 * Add specific CSS class by filter
 */
add_filter( 'body_class', 'bo_body_extra_class' );
function bo_body_extra_class( $classes ) {
    global $opt_meta_options;
     
    if(is_page() && !empty($opt_meta_options['white_bg']) && $opt_meta_options['white_bg'] == '1')
        $classes[] = 'white-bg';
        
	return $classes;
}

/**
 * Shop sidebar
 */
function bo_shop_sidebar(){
    global $opt_theme_options;

    $_sidebar = 'left';

    if(isset($opt_theme_options['woo_loop_layout']))
        $_sidebar = $opt_theme_options['woo_loop_layout'];
    
    if(isset($_GET['layout']) && trim($_GET['layout']) == 'full' )
        $_sidebar = 'full';
    if(isset($_GET['layout']) && trim($_GET['layout']) == 'left' )
        $_sidebar = 'left';
    if(isset($_GET['layout']) && trim($_GET['layout']) == 'right' )
        $_sidebar = 'right';
    return 'is-sidebar-' . esc_attr($_sidebar);
} 
/**
 * Shop product sidebar
 */
function bo_shop_single_sidebar(){
    global $opt_theme_options;

    $_sidebar = 'left';

    if(isset($opt_theme_options['woo_single_layout']))
        $_sidebar = $opt_theme_options['woo_single_layout'];
    
    if(isset($_GET['layout']) && trim($_GET['layout']) == 'full' )
        $_sidebar = 'full';
    if(isset($_GET['layout']) && trim($_GET['layout']) == 'left' )
        $_sidebar = 'left';
    if(isset($_GET['layout']) && trim($_GET['layout']) == 'right' )
        $_sidebar = 'right';
    return 'is-sidebar-' . esc_attr($_sidebar);
}
function bo_get_catalog_cols(){
    global $opt_theme_options;
    if(!isset($opt_theme_options['woo_loop_layout']))
        return 'col-xs-12 col-sm-6 col-md-4';
        
    $is_sidebar = bo_shop_sidebar();
    if($is_sidebar == 'is-sidebar-full'){
        if(isset($_GET['cols']) && trim($_GET['cols']) == 2 )
            return 'col-xs-12 col-sm-6 col-md-6';
        if(isset($_GET['cols']) && trim($_GET['cols']) == 3 )
            return 'col-xs-12 col-sm-6 col-md-4';
        if(isset($_GET['cols']) && trim($_GET['cols']) == 4 )
            return 'col-xs-12 col-sm-6 col-md-3';
        return $opt_theme_options['shop_columns_full'];
    }else{
        if(isset($_GET['cols']) && trim($_GET['cols']) == 2 )
            return 'col-xs-12 col-sm-6 col-md-6';
        if(isset($_GET['cols']) && trim($_GET['cols']) == 3 )
            return 'col-xs-12 col-sm-6 col-md-4';
        return $opt_theme_options['shop_columns'];
    }
}
/**
 * Change number product to show
 */
add_action('after_setup_theme','bo_update_woo_number_item_in_page');
function bo_update_woo_number_item_in_page(){
    global $opt_theme_options;
    if(class_exists('EF3_Framework')){
        if(class_exists( 'woocommerce' )){
            $number_product = ( !empty($opt_theme_options['shop_products']) ) ? $opt_theme_options['shop_products'] : 9;
            add_filter( 'loop_shop_per_page', create_function( '$cols', 'return '.$number_product.';' ), 9 );
        }
    }
}
 
add_action( 'woocommerce_share', 'bo_woocommerce_social_share_icons', 10 );
function bo_woocommerce_social_share_icons() { ?>
    <div class="woo-entry-share">
        <ul class="social-share">
            <li><a class="twitter" target="_blank" href="https://twitter.com/home?status=<?php esc_html_e('Check out this article', 'wpbo');?>:%20<?php echo strip_tags(get_the_title());?>%20-%20<?php the_permalink();?>"><i aria-hidden="true" class="fa fa-twitter"></i></a></li>
            <li><a class="facebook" target="_blank" href="https://www.facebook.com/sharer/sharer.php?u=<?php the_permalink();?>"><i aria-hidden="true" class="fa fa-facebook"></i></a></li>
            <li><a class="google" target="_blank" href="https://plus.google.com/share?url=<?php the_permalink();?>"><i aria-hidden="true" class="fa fa-google-plus"></i></a></li>
            <li><a class="pinterest" target="_blank" href="https://pinterest.com/pin/create/button/?url=<?php echo urlencode(get_the_permalink());?>"><i class="fa fa-pinterest"></i></a></li>
        </ul>
    </div>
<?php
}