<?php
/**
 * The Template for displaying all single portfolio
 *
 * @package CMSSuperHeroes
 * @subpackage CMS Theme
 * @since 1.0.0
 */

/* get side-bar position. */

get_header(); 

$portfolio_category = get_the_terms( get_the_ID(), 'portfolio_category', '', ' / ' );
$portfolio_tag = get_the_terms( get_the_ID(), 'portfolio_tag', '', ' / ' );
?>
 
<div class="single-fortfolios">
    <div class="container">
    <?php while ( have_posts() ) : the_post(); ?>
        <article id="post-<?php the_ID(); ?>" <?php post_class(); ?>>
            <div class="port-gallery">
                <?php bo_portfolio_gallery(); ?>
            </div>
            <div class="row">
                <div class="port-content-wrap col-xs-12 col-sm-9 col-md-9 col-lg-9">
                    <div class="port-title">
                        <h1><?php the_title();?></h1>
                    </div>
                    <div class="port-content">
                         <?php the_content();?>  
                    </div>
                    <?php
                    if(isset($opt_theme_options['single_port_sharing']) && $opt_theme_options['single_port_sharing'])
                        bo_footer_share();
                    ?>
                </div>
                <div class="port-meta col-xs-12 col-sm-3 col-md-3 col-lg-3">
                    <?php if($portfolio_category): ?>
                    <div class="meta-item">
                        <h5><?php echo count($portfolio_category) > 1 ? esc_html__('Categories:', 'wpbo') : esc_html__('Category:', 'wpbo'); ?></h5>
                        <span class="cats"><?php the_terms( get_the_ID(), 'portfolio_category', '', ' / ' ); ?></span>
                    </div>
                    <?php endif; ?>
                    <div class="meta-item">
                        <h5><?php esc_html_e('Date:', 'wpbo') ?></h5>
                        <span><?php echo get_the_date(); ?></span>
                    </div>
                    <div class="meta-item">
                        <h5><?php echo count($portfolio_tag) > 1 ? esc_html__('Tags:', 'wpbo') : esc_html__('Tag:', 'wpbo'); ?></h5>
                        <span class="tags"><?php the_terms( get_the_ID(), 'portfolio_tag', '', ', ' ); ?></span>
                    </div>
                </div>
            </div>
        	  
        </article>
        
        <?php bo_port_nav_wrap();?>
         
    <?php endwhile; // end of the loop. ?>
    </div>
    
</div>
  
<?php get_footer(); ?>