<?php
/**
 * The template for displaying Archive pages
 *
 * Used to display archive-type pages if nothing more specific matches a query.
 * For example, puts together date-based pages if no date.php file exists.
 *
 * If you'd like to further customize these archive views, you may create a
 * new template file for each specific one. For example, CMS Theme already
 * has tag.php for Tag archives, category.php for Category archives, and
 * author.php for Author archives.
 *
 * @link http://codex.wordpress.org/Template_Hierarchy
 *
 * @package CMSSuperHeroes
 * @subpackage CMS Theme
 * @since 1.0.0
 */

get_header();
?>
<div id="primary" class="container">
    <main id="main" class="site-main">
        
        <?php
			$terms = get_term_by( 'slug', get_query_var( 'portfolio_tag' ), get_query_var( 'taxonomy' ) );
			$args = array(
				'post_type' => 'portfolio', 
				'posts_per_page' => get_option('posts_per_page'), 
				'orderby' => 'date',
				'tax_query' => array(
				    array(
				      'taxonomy' => 'portfolio_tag',
				      'field' => 'id',
				      'terms' => $terms->term_id,
				      'include_children' => false
				    )
			  	)
			);
			$portfolio_post = new WP_Query($args);
		?>
        <?php if ( $portfolio_post->have_posts() ) : ?>
            <div class="cms-grid-portfolio">
                <?php
                $size = 'wpbo-370-270';
                while ( $portfolio_post->have_posts() ){
                    $portfolio_post->the_post();
                    ?>
                    <div class="cms-grid-item col-lg-4 col-md-4 col-sm-6 col-xs-12">
                        <div class="port-item-wrap">
                            <?php 
                                if(has_post_thumbnail() && !post_password_required() && !is_attachment() &&  wp_get_attachment_image_src(get_post_thumbnail_id(get_the_ID()), 'full', false)):
                                    $class = ' has-thumbnail';
                                    $thumbnail = get_the_post_thumbnail(get_the_ID(),$size);
                                else:
                                    $class = ' no-image';
                                    $thumbnail = '<img src="'.esc_url(get_template_directory_uri().'/assets/images/no-image.jpg').'" alt="'.get_the_title().'" />';
                                endif;
                                echo '<div class="cms-grid-media '.esc_attr($class).'">'.$thumbnail.'</div>';
                            ?>
                            <div class="port-item-inner">
                                <a class="port-link" href="<?php the_permalink();?>" title="<?php the_title()?>"><?php the_title();?></a>
                                <div class="port-categories">
                                    <?php echo get_the_term_list( get_the_ID(), 'portfolio_category', '', ' / ', '' ); ?>
                                </div>
                            </div>
                        </div>
                    </div>
                    <?php
                }
                ?>
            </div>
        <?php else : ?>
			<?php get_template_part( 'single-templates/content', 'none' ); ?>
		<?php endif; ?>
    </main>
</div>
<?php get_footer(); ?>
 