<?php
vc_remove_param('cms_fancybox_single', 'title');
vc_remove_param('cms_fancybox_single', 'description');
vc_remove_param('cms_fancybox_single', 'content_align');
vc_remove_param('cms_fancybox_single', 'button_text');
vc_remove_param('cms_fancybox_single', 'button_link');
vc_remove_param('cms_fancybox_single', 'button_type');

vc_add_param("cms_fancybox_single", array(
    'type' => 'img',
    'heading' => esc_html__( 'Fancy Style', 'wpbo' ),
    'value' => array(
        'style-0' => get_template_directory_uri().'/vc_params/cms-fancy-single/default.png',
        'style-1' => get_template_directory_uri().'/vc_params/cms-fancy-single/fancy-style1.png', 
        'style-2' => get_template_directory_uri().'/vc_params/cms-fancy-single/fancy-style2.png',
        'style-3' => get_template_directory_uri().'/vc_params/cms-fancy-single/fancy-style3.png',    
        'style-4' => get_template_directory_uri().'/vc_params/cms-fancy-single/fancy-style4.png',
        'style-5' => get_template_directory_uri().'/vc_params/cms-fancy-single/fancy-style5.png',
        'style-6' => get_template_directory_uri().'/vc_params/cms-fancy-single/fancy-style6.png',
    ),
    'param_name' => 'fancy_style',
    "admin_label" => true,
    'description' => esc_html__( 'Select fancybox style', 'wpbo' ),
    "group" => esc_html__("Layout", 'wpbo'),
    'weight' => 1
));
 
vc_add_param("cms_fancybox_single", array(
    "type" => "textfield",
    "heading" => esc_html__("Extra Class",'wpbo'),
    "param_name" => "class",
    "value" => "",
    "description" => "",
    "group" => esc_html__("Layout", 'wpbo'),
    'weight' => 1
));
vc_add_param('cms_fancybox_single', array(
    "type" => "dropdown",
	"class" => "",
	"heading" => esc_html__ ( "Size style", 'wpbo' ),
	"param_name" => "size",
	"value" => array (
        esc_html__("Default", 'wpbo') => "",
		esc_html__("Small", 'wpbo') => "size-small",
		esc_html__("Large", 'wpbo') => "size-large" 
	),
	"std" => "",
	'weight' => 1,
    'dependency' => array(
        'element' => 'fancy_style',
        'value' => array(
            'style-2', 
        ),
    ),
    'group' => esc_html__("Layout",'wpbo'),
));

vc_add_param("cms_fancybox_single", array(
    "type" => "cms_template",
    "param_name" => "cms_template",
    "heading" => esc_html__("Shortcode Template", 'wpbo'),
    "shortcode" => "cms_fancybox_single",
    "group" => esc_html__("Layout", 'wpbo'),
    'weight' => 1
));
vc_add_param("cms_fancybox_single", array(
    'type' => 'dropdown',
	'heading' => esc_html__( 'Icon library', 'wpbo' ),
	'value' => array(
		esc_html__( 'Font Awesome', 'wpbo' ) => 'fontawesome',
		esc_html__( 'Open Iconic', 'wpbo' ) => 'openiconic',
		esc_html__( 'Typicons', 'wpbo' ) => 'typicons',
		esc_html__( 'Entypo', 'wpbo' ) => 'entypo',
		esc_html__( 'Linecons', 'wpbo' ) => 'linecons',
		esc_html__( 'Pixel', 'wpbo' ) => 'pixelicons',
		esc_html__( 'P7 Stroke', 'wpbo' ) => 'pe7stroke',
		esc_html__( 'RT Icon', 'wpbo' ) => 'rticon',
	),
	'param_name' => 'icon_type',
	'description' => esc_html__( 'Select icon library.', 'wpbo' ),
    'dependency' => array(
        'element' => 'fancy_style',
        'value' => array(
            'style-0',
            'style-1',
            'style-2',
            'style-3', 
            'style-4',
            'style-5',
        ),
    ),
	"group" => esc_html__("Fancy Icon Settings", 'wpbo')
));
 
vc_add_param("cms_fancybox_single", array(
    "type" => "attach_image",
    "heading" => esc_html__("Image Item",'wpbo'),
    "param_name" => "image",
    'dependency' => array(
        'element' => 'fancy_style',
        'value' => array(
            'style-0',
            'style-6',
        ),
    ),
    "group" => esc_html__("Option", 'wpbo')
));


vc_add_param("cms_fancybox_single", array(
	"type" => "textfield",
    "heading" => esc_html__("Title Item",'wpbo'),
    "param_name" => "title_item",
    "value" => "",
    "admin_label" => true,
    "description" => esc_html__("Title Of Item",'wpbo'),
    "group" => esc_html__("Option", 'wpbo')
));

vc_add_param("cms_fancybox_single", array(
	"type" => "textarea",
    "heading" => esc_html__("Content Item",'wpbo'),
    "param_name" => "description_item",
    "group" => esc_html__("Option", 'wpbo')
));

vc_add_param("cms_fancybox_single", array(
	'type' => 'vc_link',
    'heading' => esc_html__( 'URL (Link)', 'wpbo' ),
    'param_name' => 'link',
    'description' => esc_html__( 'Add link to button.', 'wpbo' ),
    "group" => esc_html__("Option", 'wpbo'),
    'dependency' => array(
        'element' => 'fancy_style',
        'value' => array(
            'style-0',
            'style-5',
            'style-6',
        ),
    ),
));

vc_add_param("cms_fancybox_single", array(
	'type' => 'css_editor',
    'heading' => esc_html__( 'CSS box', 'wpbo' ),
    'param_name' => 'css',
    'group' => esc_html__( 'Design Options', 'wpbo' ),
));
 