<?php 
    $atts = vc_map_get_attributes( $this->getShortcode(), $atts );
    extract( $atts );
    $classes=array('cms-team',vc_shortcode_custom_css_class( $css ));
    $link = (isset($atts['link'])) ? $atts['link'] : '';
    $link = vc_build_link( $link );
    $use_link = false;
    if ( strlen( $link['url'] ) > 0 ) {
        $use_link = true;
        $a_href = $link['url'];
        $a_title = $link['title'];
        $a_target = strlen( $link['target'] ) > 0 ? $link['target'] : '_self';
    }
    if(!empty($atts['css'])){
        $classes[]=vc_shortcode_custom_css_class($atts['css']);
    }
    $css_class = preg_replace( '/\s+/', ' ', apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, implode( ' ', array_filter( $classes ) ), $this->settings['base'], $atts ) );
 
    $image_url = '';
    if (!empty($atts['image'])) {
        $attachment_image = wp_get_attachment_image_src($atts['image'], 'thumbnail');
        $image_url = $attachment_image[0];
    } 
    $socials=(array) vc_param_group_parse_atts($socials );
?>
 
<div class="<?php echo esc_attr($css_class); ?> text-center">
	<?php if(!empty($image_url)):?>
        <div class="avatar">
            <img src="<?php echo esc_url($image_url);?>" alt=""/>
        </div>
    <?php endif; ?>
    <div class="team-detail">
        <?php if(!empty($name)):?>
            <?php if($use_link):?>
                <a class="name" href="<?php echo $a_href;?>" target="<?php echo $a_target;?>"><?php echo esc_html($name);?></a>
            <?php else:?>
                <h4 class="name"><?php echo esc_html($name);?></h4>
            <?php endif;?>
        <?php endif; ?>  
        <?php if(!empty($position)):?>
            <span class="position"><?php echo esc_html($position);?></span>
        <?php endif; ?>    
        <?php if(!empty($desc)):?>
            <p class="desc"><?php echo esc_html($desc);?></p>
        <?php endif; ?> 
        <?php if(!empty($socials)): ?>    
            <div class="social-icons">
                <ul class="list-inline">
                    <?php 
                    foreach($socials as $social):
                    ?>
                        <li>
                        <a href="<?php echo !empty($social['link'])? esc_url($social['link']):'#';?>">
                        <?php if(!empty($social['icon'])):?>
                        <i class="<?php echo esc_html($social['icon']);?>"></i>
                        <?php endif; ?>
                        </a>
                        </li>
                    <?php endforeach; ?>
                </ul>
            </div> 
        <?php endif; ?>
    </div> 
</div>
 
	 
             

