<?php

remove_action('woocommerce_before_main_content', 'woocommerce_breadcrumb', 20);

/* Cross Sell Product */
remove_action( 'woocommerce_cart_collaterals', 'woocommerce_cross_sell_display' );

/* Loop product */

remove_action('woocommerce_before_shop_loop_item', 'woocommerce_template_loop_product_link_open', 10);
remove_action('woocommerce_after_shop_loop_item', 'woocommerce_template_loop_product_link_close', 5);
remove_action('woocommerce_before_shop_loop_item_title', 'woocommerce_template_loop_product_thumbnail', 10);
add_action('woocommerce_before_shop_loop_item_title', 'bo_template_loop_product_thumbnail', 10);

remove_action('woocommerce_shop_loop_item_title', 'woocommerce_template_loop_product_title', 10);
add_action('woocommerce_shop_loop_item_title', 'bo_template_loop_product_title', 10);
remove_action('woocommerce_after_shop_loop_item_title', 'woocommerce_template_loop_price', 10);
add_action('woocommerce_after_shop_loop_item_title', 'woocommerce_template_loop_price', 5);
 
remove_action('woocommerce_before_main_content', 'woocommerce_output_content_wrapper', 10);
remove_action('woocommerce_after_main_content', 'woocommerce_output_content_wrapper_end', 10);
add_action('woocommerce_before_main_content', 'bo_output_content_wrapper', 10);
add_action('woocommerce_after_main_content', 'bo_output_content_wrapper_end', 10);

remove_action('woocommerce_before_single_product_summary', 'woocommerce_show_product_images', 20);
add_action('woocommerce_before_single_product_summary', 'bo_show_product_images', 20);
remove_action('woocommerce_before_single_product_summary', 'woocommerce_show_product_sale_flash', 10);
remove_action('woocommerce_after_single_product_summary', 'woocommerce_upsell_display', 15);
remove_action('woocommerce_after_single_product_summary', 'woocommerce_output_related_products', 20);
add_action( 'cms_single_product_related', 'woocommerce_output_related_products', 20 );
//add_action('woocommerce_after_single_product_summary', 'bo_output_recent_products', 20);

/**
 * Get the product thumbnail for the loop.
 */
function bo_template_loop_product_thumbnail() {
    global $opt_theme_options;
	echo '<div class="shop-media entry" onclick="">';
    echo '<a href="' . get_the_permalink() . '">';
    if((!empty($opt_theme_options['woo_loop_layout']) && $opt_theme_options['woo_loop_layout'] != 'full') || (isset($_GET['layout']) && trim($_GET['layout']) != 'full' )){
        echo woocommerce_get_product_thumbnail();
    }else{
        echo woocommerce_get_product_thumbnail( 'wpbo-570-493');  
    }
	echo '</a></div>';
}

/**
 * Get the product title for the loop.
 */
function bo_template_loop_product_title() {
	echo '<h3 class="product-title">';
	echo '<a href="' . get_the_permalink() . '" class="p-title">'.get_the_title().'</a>';
	echo '</h3>';
    
}

function bo_output_content_wrapper(){
    echo '<div class="shop-wrapper">';   
}

function bo_output_content_wrapper_end(){
    echo '</div>';
}

function bo_show_product_images(){
     global $post, $product;
        
        $attachment_ids = $product->get_gallery_image_ids();

        $has_col_thumb_cls = ( $attachment_ids && has_post_thumbnail() ) ? 'has-col-thumb' : '';
	    	 
        $post_thumbnail_id = get_post_thumbnail_id( $post->ID );
        $full_size_image   = wp_get_attachment_image_src( $post_thumbnail_id, 'full' );
        $image_title       = get_post_field( 'post_excerpt', $post_thumbnail_id );
      
        $attributes = array(
			'title'                   => $image_title,
			'data-src'                => $full_size_image[0],
			'data-large_image'        => $full_size_image[0],
			'data-large_image_width'  => $full_size_image[1],
			'data-large_image_height' => $full_size_image[2],
		);
        if ( has_post_thumbnail() ) {
			$html  = '<div class="woocommerce-product-gallery__image"><a class="magic-popup" href="' . esc_url( $full_size_image[0] ) . '">';
			$html .= get_the_post_thumbnail( $post->ID, 'shop_single', $attributes );
			$html .= '</a></div>';
		} else {
			$html  = '<div class="woocommerce-product-gallery__image--placeholder">';
			$html .= sprintf( '<img src="%s" alt="%s" class="wp-post-image" />', esc_url( wc_placeholder_img_src() ), esc_html__( 'Awaiting product image', 'wpbo' ) );
			$html .= '</div>';
		}
        echo '<div class="col-img '.esc_attr($has_col_thumb_cls).'">';
            echo apply_filters( 'woocommerce_single_product_image_thumbnail_html', $html, get_post_thumbnail_id( $post->ID ) );
        echo '</div>';
        echo '<div class="col-thumb '.esc_attr($has_col_thumb_cls).'">'; 
		  do_action( 'woocommerce_product_thumbnails' );
        echo '</div>';
     
}

 
/* Remove field label */
add_filter( 'woocommerce_form_field_args' , 'bo_override_woocommerce_form_field' );
function bo_override_woocommerce_form_field( $args ) {
    $args['label'] = false;    
    return $args;
}
 

/* Overide checkout field */
function bo_override_checkout_fields( $fields ) {
    $fields['billing']['billing_first_name']['placeholder'] = esc_html__('First Name*','wpbo');
    $fields['billing']['billing_last_name']['placeholder'] = esc_html__('Last Name*','wpbo');
    $fields['billing']['billing_company']['placeholder'] = esc_html__('Company Name','wpbo');
    $fields['billing']['billing_email']['placeholder'] = esc_html__('Email Address*','wpbo');
    $fields['billing']['billing_phone']['placeholder'] = esc_html__('Phone*','wpbo');
    $fields['billing']['billing_city']['placeholder'] = esc_html__('City*','wpbo');
    $fields['billing']['billing_postcode']['placeholder'] = esc_html__('Postcode*','wpbo');
    $fields['billing']['billing_state']['placeholder'] = esc_html__('State*','wpbo');
    $fields['billing']['billing_country']['placeholder'] = esc_html__('Country*','wpbo');
    $fields['billing']['billing_address_1']['placeholder'] = esc_html__('Billing Address*','wpbo');
    $fields['billing']['billing_address_2']['placeholder'] = esc_html__('Billing Address 2','wpbo');
    

    $fields['shipping']['shipping_first_name']['placeholder'] = esc_html__('First Name*','wpbo');
    $fields['shipping']['shipping_last_name']['placeholder'] = esc_html__('Last Name*','wpbo');
    $fields['shipping']['shipping_company']['placeholder'] = esc_html__('Company Name','wpbo');
    $fields['shipping']['shipping_city']['placeholder'] = esc_html__('City*','wpbo');
    $fields['shipping']['shipping_postcode']['placeholder'] = esc_html__('Postcode*','wpbo');
    $fields['shipping']['shipping_state']['placeholder'] = esc_html__('State*','wpbo');
    $fields['shipping']['shipping_country']['placeholder'] = esc_html__('Country*','wpbo');
    
    $fields['account']['account_username']['placeholder'] = esc_html__('Username or email*','wpbo');
    $fields['account']['account_password']['placeholder'] = esc_html__('Password*','wpbo');
    $fields['account']['account_password-2']['placeholder'] = esc_html__('Retype Password*','wpbo');

    $fields['order']['order_comments']['placeholder'] = esc_html__('Order Notes','wpbo');

    /* Add Email/ Phone on Shipping fields*/
    $fields['shipping']['shipping_phone'] = array(
		'label'     	=> esc_html__('Phone', 'wpbo'),
		'placeholder'   => _x('Phone', 'placeholder', 'wpbo'),
		'required'  	=> false,
		'class'     	=> array('form-row-first'),
		'clear'     	=> true,
		
	);
    $fields['shipping']['shipping_email'] = array(
		'label'     	=> esc_html__('Email Address', 'wpbo'),
		'placeholder'   => _x('Email Address', 'placeholder', 'wpbo'),
		'required'  	=> false,
		'class'     	=> array('form-row-last'),
		'clear'     	=> false
	);
    
    $fields['shipping']['shipping_city'] = array(
		'label'     	=> esc_html__('City', 'wpbo'),
		'placeholder'   => _x('City*', 'placeholder', 'wpbo'),
		'required'  	=> false,
		'class'     	=> array('form-row-first'),
		'clear'     	=> false
	);
    $fields['shipping']['shipping_postcode'] = array(
		'label'     	=> esc_html__('Post Code', 'wpbo'),
		'placeholder'   => _x('Post Code*', 'placeholder', 'wpbo'),
		'required'  	=> false,
		'class'     	=> array('form-row-last'),
		'clear'     	=> true,
	 
	);
    return $fields;
}
add_filter( 'woocommerce_checkout_fields' , 'bo_override_checkout_fields' );

/* Reordering Checkout form field */
add_filter("woocommerce_checkout_fields", "bo_order_fields");
function bo_order_fields($fields) {
    $order = array(
        "billing_first_name", 
        "billing_last_name", 
        "billing_phone",
        "billing_email", 
        "billing_company", 
        "billing_address_1", 
        "billing_address_2",
        "billing_country",
        "billing_city",
        "billing_state",
        "billing_postcode", 
         
    );
    foreach($order as $field)
    {
        $ordered_fields[$field] = $fields["billing"][$field];
    }
     
    return $fields;
}
add_filter("woocommerce_checkout_fields", "bo_shipping_order_fields");
function bo_shipping_order_fields($fields) {
    $order = array(
    	
        "shipping_first_name", 
        "shipping_last_name", 
        "shipping_phone",
        "shipping_email", 
        "shipping_company", 
        "shipping_country",
        "shipping_address_1", 
        "shipping_address_2",
        "shipping_city",
        "shipping_state",
        "shipping_postcode", 
         
    );
    foreach($order as $field)
    {
        $ordered_fields[$field] = $fields["shipping"][$field];
    }
    $fields["shipping"] = $ordered_fields;   
    return $fields;
}	

