<?php 
/* Loads Stroke 7 Icon Font. */
add_filter( 'vc_iconpicker-type-pe7stroke', 'vc_iconpicker_type_pe7stroke' );

/**
 * Pe7 Stroke icons from themes-pixeden.com/
 *
 * @param $icons - taken from filter - vc_map param field settings['source'] provided icons (default empty array).
 * If array categorized it will auto-enable category dropdown
 *
 * @since 4.4
 * @return array - of icons for iconpicker, can be categorized, or not.
 */
function vc_iconpicker_type_pe7stroke( $icons ) {
	$pe7stroke_icons = array(
		array( "pe-7s-album" => __( "Album", "js_composer" ) ),
		array( "pe-7s-arc" => __( "arc", "js_composer" ) ),
		array( "pe-7s-back-2" => __( "back-2", "js_composer" ) ),
		array( "pe-7s-bandaid" => __( "bandaid", "js_composer" ) ),
		array( "pe-7s-car" => __( "car", "js_composer" ) ),
		array( "pe-7s-diamond" => __( "diamond", "js_composer" ) ),
		array( "pe-7s-door-lock" => __( "door-lock", "js_composer" ) ),
		array( "pe-7s-eyedropper" => __( "eyedropper", "js_composer" ) ),
		array( "pe-7s-female" => __( "female", "js_composer" ) ),
		array( "pe-7s-gym" => __( "gym", "js_composer" ) ),
		array( "pe-7s-hammer" => __( "hammer", "js_composer" ) ),
		array( "pe-7s-headphones" => __( "headphones", "js_composer" ) ),
		array( "pe-7s-helm" => __( "helm", "js_composer" ) ),
		array( "pe-7s-hourglass" => __( "hourglass", "js_composer" ) ),
		array( "pe-7s-leaf" => __( "leaf", "js_composer" ) ),
		array( "pe-7s-magic-wand" => __( "magic wand", "js_composer" ) ),
		array( "pe-7s-male" => __( "male", "js_composer" ) ),
		array( "pe-7s-map-2" => __( "map 2", "js_composer" ) ),
		array( "pe-7s-next-2" => __( "next 2", "js_composer" ) ),
		array( "pe-7s-paint-bucket" => __( "paint bucket", "js_composer" ) ),
		array( "pe-7s-pendrive" => __( "pendrive", "js_composer" ) ),
		array( "pe-7s-photo" => __( "photo", "js_composer" ) ),
		array( "pe-7s-piggy" => __( "piggy", "js_composer" ) ),
		array( "pe-7s-plugin" => __( "plugin", "js_composer" ) ),
		array( "pe-7s-refresh-2" => __( "refresh 2", "js_composer" ) ),
		array( "pe-7s-rocket" => __( "rocket", "js_composer" ) ),
		array( "pe-7s-settings" => __( "settings", "js_composer" ) ),
		array( "pe-7s-shield" => __( "shield", "js_composer" ) ),
		array( "pe-7s-smile" => __( "smile", "js_composer" ) ),
		array( "pe-7s-usb" => __( "usb", "js_composer" ) ),
		array( "pe-7s-vector" => __( "vector", "js_composer" ) ),
		array( "pe-7s-wine" => __( "wine", "js_composer" ) ),
		array( "pe-7s-cloud-upload" => __( "cloud upload", "js_composer" ) ),
		array( "pe-7s-cash" => __( "cash", "js_composer" ) ),
		array( "pe-7s-close" => __( "close", "js_composer" ) ),
		array( "pe-7s-bluetooth" => __( "bluetooth", "js_composer" ) ),
		array( "pe-7s-cloud-download" => __( "cloud download", "js_composer" ) ),
		array( "pe-7s-way" => __( "way", "js_composer" ) ),
		array( "pe-7s-close-circle" => __( "close circle", "js_composer" ) ),
		array( "pe-7s-id" => __( "id", "js_composer" ) ),
		array( "pe-7s-angle-up" => __( "angle up", "js_composer" ) ),
		array( "pe-7s-wristwatch" => __( "wristwatch", "js_composer" ) ),
		array( "pe-7s-angle-up-circle" => __( "angle upcircle", "js_composer" ) ),
		array( "pe-7s-world" => __( "world", "js_composer" ) ),
		array( "pe-7s-angle-right" => __( "Angle Right", "js_composer" ) ),
		array( "pe-7s-volume" => __( "volume", "js_composer" ) ),
		array( "pe-7s-angle-right-circle" => __( "angle right circle", "js_composer" ) ),
		array( "pe-7s-users" => __( "Users", "js_composer" ) ),
		array( "pe-7s-angle-left" => __( "angle left", "js_composer" ) ),
		array( "pe-7s-user-female" => __( "user female", "js_composer" ) ),
		array( "pe-7s-angle-left-circle" => __( "angle left circle", "js_composer" ) ),
		array( "pe-7s-up-arrow" => __( "Up Arrow", "js_composer" ) ),
		array( "pe-7s-angle-down" => __( "Angle Down", "js_composer" ) ),
		array( "pe-7s-switch" => __( "switch", "js_composer" ) ),
		array( "pe-7s-angle-down-circle" => __( "angle down circle", "js_composer" ) ),
		array( "pe-7s-scissors" => __( "scissors", "js_composer" ) ),
		array( "pe-7s-wallet" => __( "wallet", "js_composer" ) ),
		array( "pe-7s-safe" => __( "safe", "js_composer" ) ),
		array( "pe-7s-volume2" => __( "volume2", "js_composer" ) ),
		array( "pe-7s-volume1" => __( "volume1", "js_composer" ) ),
		array( "pe-7s-voicemail" => __( "voice mail", "js_composer" ) ),
		array( "pe-7s-video" => __( "video", "js_composer" ) ),
		array( "pe-7s-user" => __( "user", "js_composer" ) ),
		array( "pe-7s-upload" => __( "upload", "js_composer" ) ),
		array( "pe-7s-unlock" => __( "unlock", "js_composer" ) ),
		array( "pe-7s-umbrella" => __( "umbrella", "js_composer" ) ),
		array( "pe-7s-trash" => __( "trash", "js_composer" ) ),
		array( "pe-7s-tools" => __( "tools", "js_composer" ) ),
		array( "pe-7s-timer" => __( "timer", "js_composer" ) ),
		array( "pe-7s-ticket" => __( "ticket", "js_composer" ) ),
		array( "pe-7s-target" => __( "target", "js_composer" ) ),
		array( "pe-7s-sun" => __( "sun", "js_composer" ) ),
		array( "pe-7s-study" => __( "study", "js_composer" ) ),
		array( "pe-7s-stopwatch" => __( "stopwatch", "js_composer" ) ),
		array( "pe-7s-star" => __( "star", "js_composer" ) ),
		array( "pe-7s-speaker" => __( "speaker", "js_composer" ) ),
		array( "pe-7s-signal" => __( "signal", "js_composer" ) ),
		array( "pe-7s-shuffle" => __( "shuffle", "js_composer" ) ),
		array( "pe-7s-shopbag" => __( "shopbag", "js_composer" ) ),
		array( "pe-7s-share" => __( "share", "js_composer" ) ),
		array( "pe-7s-server" => __( "server", "js_composer" ) ),
		array( "pe-7s-search" => __( "search", "js_composer" ) ),
		array( "pe-7s-film" => __( "film", "js_composer" ) ),
		array( "pe-7s-science" => __( "science", "js_composer" ) ),
		array( "pe-7s-disk" => __( "disk", "js_composer" ) ),
		array( "pe-7s-ribbon" => __( "ribbon", "js_composer" ) ),
		array( "pe-7s-repeat" => __( "repeat", "js_composer" ) ),
		array( "pe-7s-refresh" => __( "refresh", "js_composer" ) ),
		array( "pe-7s-add-user" => __( "add user", "js_composer" ) ),
		array( "pe-7s-refresh-cloud" => __( "refresh cloud", "js_composer" ) ),
		array( "pe-7s-paperclip" => __( "paperclip", "js_composer" ) ),
		array( "pe-7s-radio" => __( "radio", "js_composer" ) ),
		array( "pe-7s-note2" => __( "note2", "js_composer" ) ),
		array( "pe-7s-print" => __( "print", "js_composer" ) ),
		array( "pe-7s-network" => __( "network", "js_composer" ) ),
		array( "pe-7s-prev" => __( "prev", "js_composer" ) ),
		array( "pe-7s-mute" => __( "mute", "js_composer" ) ),
		array( "pe-7s-power" => __( "power", "js_composer" ) ),
		array( "pe-7s-medal" => __( "medal", "js_composer" ) ),
		array( "pe-7s-portfolio" => __( "portfolio", "js_composer" ) ),
		array( "pe-7s-like2" => __( "like2", "js_composer" ) ),
		array( "pe-7s-plus" => __( "plus", "js_composer" ) ),
		array( "pe-7s-play" => __( "play", "js_composer" ) ),
		array( "pe-7s-key" => __( "key", "js_composer" ) ),
		array( "pe-7s-plane" => __( "plane", "js_composer" ) ),
		array( "pe-7s-joy" => __( "joy", "js_composer" ) ),
		array( "pe-7s-photo-gallery" => __( "photo gallery", "js_composer" ) ),
		array( "pe-7s-pin" => __( "pin", "js_composer" ) ),
		array( "pe-7s-phone" => __( "phone", "js_composer" ) ),
		array( "pe-7s-plug" => __( "plug", "js_composer" ) ),
		array( "pe-7s-pen" => __( "pen", "js_composer" ) ),
		array( "pe-7s-paper-plane" => __( "paper plane", "js_composer" ) ),
		array( "pe-7s-delete-user" => __( "delete user", "js_composer" ) ),
		array( "pe-7s-paint" => __( "paint", "js_composer" ) ),
		array( "pe-7s-top-arrow" => __( "top arrow", "js_composer" ) ),
		array( "pe-7s-right-arrow" => __( "right arrow", "js_composer" ) ),
		array( "pe-7s-bottom-arrow" => __( "bottom arrow", "js_composer" ) ),
		array( "pe-7s-left-arrow" => __( "left arrow", "js_composer" ) ),
		array( "pe-7s-notebook" => __( "notebook", "js_composer" ) ),
		array( "pe-7s-note" => __( "note", "js_composer" ) ),
		array( "pe-7s-next" => __( "next", "js_composer" ) ),
		array( "pe-7s-news-paper" => __( "news paper", "js_composer" ) ),
		array( "pe-7s-musiclist" => __( "musiclist", "js_composer" ) ),
		array( "pe-7s-music" => __( "music", "js_composer" ) ),
		array( "pe-7s-mouse" => __( "mouse", "js_composer" ) ),
		array( "pe-7s-more" => __( "more", "js_composer" ) ),
		array( "pe-7s-moon" => __( "moon", "js_composer" ) ),
		array( "pe-7s-monitor" => __( "monitor", "js_composer" ) ),
		array( "pe-7s-micro" => __( "micro", "js_composer" ) ),
		array( "pe-7s-menu" => __( "menu", "js_composer" ) ),
		array( "pe-7s-map" => __( "map", "js_composer" ) ),
		array( "pe-7s-map-marker" => __( "map marker", "js_composer" ) ),
		array( "pe-7s-mail" => __( "mail", "js_composer" ) ),
		array( "pe-7s-mail-open" => __( "mail open", "js_composer" ) ),
		array( "pe-7s-mail-open-file" => __( "mail open file", "js_composer" ) ),
		array( "pe-7s-magnet" => __( "magnet", "js_composer" ) ),
		array( "pe-7s-loop" => __( "loop", "js_composer" ) ),
		array( "pe-7s-look" => __( "look", "js_composer" ) ),
		array( "pe-7s-lock" => __( "lock", "js_composer" ) ),
		array( "pe-7s-lintern" => __( "lintern", "js_composer" ) ),
		array( "pe-7s-link" => __( "link", "js_composer" ) ),
		array( "pe-7s-like" => __( "like", "js_composer" ) ),
		array( "pe-7s-light" => __( "light", "js_composer" ) ),
		array( "pe-7s-less" => __( "less", "js_composer" ) ),
		array( "pe-7s-keypad" => __( "keypad", "js_composer" ) ),
		array( "pe-7s-junk" => __( "junk", "js_composer" ) ),
		array( "pe-7s-info" => __( "info", "js_composer" ) ),
		array( "pe-7s-home" => __( "home", "js_composer" ) ),
		array( "pe-7s-help2" => __( "help2", "js_composer" ) ),
		array( "pe-7s-help1" => __( "help1", "js_composer" ) ),
		array( "pe-7s-graph3" => __( "graph3", "js_composer" ) ),
		array( "pe-7s-graph2" => __( "graph2", "js_composer" ) ),
		array( "pe-7s-graph1" => __( "graph1", "js_composer" ) ),
		array( "pe-7s-graph" => __( "graph3", "js_composer" ) ),
		array( "pe-7s-global" => __( "global", "js_composer" ) ),
		array( "pe-7s-gleam" => __( "gleam", "js_composer" ) ),
		array( "pe-7s-glasses" => __( "glasses", "js_composer" ) ),
		array( "pe-7s-gift" => __( "gift", "js_composer" ) ),
		array( "pe-7s-folder" => __( "folder", "js_composer" ) ),
		array( "pe-7s-flag" => __( "flag", "js_composer" ) ),
		array( "pe-7s-filter" => __( "filter", "js_composer" ) ),
		array( "pe-7s-file" => __( "file", "js_composer" ) ),
		array( "pe-7s-expand1" => __( "expand1", "js_composer" ) ),
		array( "pe-7s-exapnd2" => __( "expand2", "js_composer" ) ),
		array( "pe-7s-edit" => __( "edit", "js_composer" ) ),
		array( "pe-7s-drop" => __( "drop", "js_composer" ) ),
		array( "pe-7s-drawer" => __( "drawer", "js_composer" ) ),
		array( "pe-7s-download" => __( "download", "js_composer" ) ),
		array( "pe-7s-display2" => __( "display2", "js_composer" ) ),
		array( "pe-7s-display1" => __( "display1", "js_composer" ) ),
		array( "pe-7s-diskette" => __( "diskette", "js_composer" ) ),
		array( "pe-7s-date" => __( "date", "js_composer" ) ),
		array( "pe-7s-cup" => __( "cup", "js_composer" ) ),
		array( "pe-7s-culture" => __( "culture", "js_composer" ) ),
		array( "pe-7s-crop" => __( "crop", "js_composer" ) ),
		array( "pe-7s-credit" => __( "credit", "js_composer" ) ),
		array( "pe-7s-copy-file" => __( "copy file", "js_composer" ) ),
		array( "pe-7s-config" => __( "config", "js_composer" ) ),
		array( "pe-7s-compass" => __( "compass", "js_composer" ) ),
		array( "pe-7s-comment" => __( "comment", "js_composer" ) ),
		array( "pe-7s-coffee" => __( "coffee", "js_composer" ) ),
		array( "pe-7s-cloud" => __( "cloud", "js_composer" ) ),
		array( "pe-7s-clock" => __( "clock", "js_composer" ) ),
		array( "pe-7s-check" => __( "check", "js_composer" ) ),
		array( "pe-7s-chat" => __( "chat", "js_composer" ) ),
		array( "pe-7s-cart" => __( "cart", "js_composer" ) ),
		array( "pe-7s-camera" => __( "Camera", "js_composer" ) ),
		array( "pe-7s-call" => __( "call", "js_composer" ) ),
		array( "pe-7s-calculator" => __( "calculator", "js_composer" ) ),
		array( "pe-7s-browser" => __( "browser", "js_composer" ) ),
		array( "pe-7s-box2" => __( "box2", "js_composer" ) ),
		array( "pe-7s-box1" => __( "box1", "js_composer" ) ),
		array( "pe-7s-bookmarks" => __( "bookmarks", "js_composer" ) ),
		array( "pe-7s-bicycle" => __( "bicycle", "js_composer" ) ),
		array( "pe-7s-bell" => __( "bell", "js_composer" ) ),
		array( "pe-7s-battery" => __( "battery", "js_composer" ) ),
		array( "pe-7s-ball" => __( "ball", "js_composer" ) ),
		array( "pe-7s-back" => __( "back", "js_composer" ) ),
		array( "pe-7s-attention" => __( "attention", "js_composer" ) ),
		array( "pe-7s-anchor" => __( "anchor", "js_composer" ) ),
		array( "pe-7s-albums" => __( "albums", "js_composer" ) ),
		array( "pe-7s-alarm" => __( "alarm", "js_composer" ) ),
		array( "pe-7s-airplay" => __( "airplay", "js_composer" ) ),
	);

	return array_merge( $icons, $pe7stroke_icons );
}
 ?>